//Player States
freeslot("S_MILNE_KICK")
freeslot("SPR2_FKIK")
states[S_MILNE_KICK] = {SPR_PLAY, SPR2_FKIK, 3, nil, 0, 0, S_MILNE_KICK}

//Kirby junk
if not kirbyabilitytable
    rawset(_G, "kirbyabilitytable", {})
end

kirbyabilitytable[MT_THROWNCRYSTAL] = 6
kirbyabilitytable["milne"] = 3

//milnegrief command
local milneable = true
local milneshield = true
addHook("NetVars", function(network)
	milneable = network($)
	milneshield = network($)
end)

COM_AddCommand("milnegrief", function(player, arg)
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			milneable = false
			CONS_Printf(player, "Milne can no longer pick up pushables and other players.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			milneable = true
			CONS_Printf(player, "Milne can now hit pick up pushables and other players.")
		elseif milneable
			CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables and other players in addition to enemies. Currently on, which is the default.")
		else
			CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables and other players in addition to enemies. Currently off, which is no fun.")
		end
	elseif milneable
		CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables and other players in addition to enemies. Currently on, which is the default.")
	else
		CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables and other players in addition to enemies. Currently off, which is no fun.")
	end
end, 1)

COM_AddCommand("milneshield", function(player, arg)
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			milneshield = false
			CONS_Printf(player, "Milne can no longer give shields to other players.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			milneshield = true
			CONS_Printf(player, "Milne can now give shields to other players.")
		elseif milneshield
			CONS_Printf(player, "milneshield [on/off] - When on, Milne players can give crystal shields to other players. Currently on, which is the default.")
		else
			CONS_Printf(player, "milneshield [on/off] - When on, Milne players can give crystal shields to other players. Currently off, which is just sad.")
		end
	elseif milneshield
		CONS_Printf(player, "milneshield [on/off] - When on, Milne players can give crystal shields to other players. Currently on, which is the default.")
	else
		CONS_Printf(player, "milneshield [on/off] - When on, Milne players can give crystal shields to other players. Currently off, which is just sad.")
	end
end, 1)

//Function for resetting/throwing objects Milne is carrying
local DropMilneCarry = function(player, throwing)
	if not player.mo and player.mo.valid
		print("A Milne-carried object has failed to drop properly because the player carrying the object doesn't exist!")
	end
	
	if player.milneprevflags == nil
		player.milneprevflags = player.milnecarry.info.flags
	end
		
	if player.milneprevflags&MF_ENEMY or player.milnecarry.type == MT_TNTBARREL
	or player.milneprevflags&MF_MONITOR
		player.milnecarry.target = player.mo
		player.milnecarry.flags = MF_MISSILE
		player.milnecarry.milnethrown = true
	else
		player.milnecarry.flags = player.milneprevflags
		if player.milnecarry.player
			P_ResetPlayer(player.milnecarry.player)
			if not throwing
				player.milnecarry.state = S_PLAY_FALL
			elseif gametyperules&GTR_FRIENDLY or
			(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam)
				player.milnecarry.state = S_PLAY_ROLL
				player.milnecarry.player.pflags = $|PF_SPINNING
			else
				player.milnecarry.state = S_PLAY_PAIN
			end
		elseif player.milnecarry.type == MT_MINUS
			player.milnecarry.state = player.milnecarry.info.missilestate
		else
			player.milnecarry.state = player.milnecarry.info.spawnstate
		end
		if player.milnecarry.battleobject
			player.milnecarry.target = player.mo
		end
	end
		
	if throwing
		local speed = 40
		if P_GetPlayerControlDirection(player) == 0
		or (abs(player.cmd.forwardmove) < 35 and abs(player.cmd.sidemove) < 35)
			speed = 10
		end
		
		//Aim your throw
		//You can only aim players at objects if they're on your team
		//Pushables and bots can't be aimed at monitors
		local lockon = P_LookForEnemies(player, false,
		not(player.milnecarry.flags&MF_PUSHABLE
		or (player.milnecarry.player and player.milnecarry.player.bot)))
		if lockon and lockon.valid and (player.milnecarry.flags&MF_MISSILE
		or player.milnecarry.flags&MF_PUSHABLE
		or (player.milnecarry.player and (gametyperules&GTR_FRIENDLY or
		(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam))))
			speed = 60
			player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
			player.drawangle = player.mo.angle
			local zthing = player.milnecarry.z
			if player.mo.eflags & MFE_VERTICALFLIP
				zthing = $+player.milnecarry.height
			end
			if lockon.eflags & MFE_VERTICALFLIP
				zthing = lockon.z - $
			else
				zthing = (lockon.z+lockon.height) - $
			end
			player.milnecarry.momz = zthing / max(P_AproxDistance(lockon.x - player.mo.x, lockon.y - player.mo.y)/max(speed*player.mo.scale, player.speed*2),1)
			if not (player.mo.eflags&MFE_UNDERWATER)
				P_SetObjectMomZ(player.milnecarry, FRACUNIT, true)
			end
			if player.milnecarry.momz*P_MobjFlip(player.mo) < 0
			and player.milnecarry.flags&MF_PUSHABLE
				P_SetObjectMomZ(player.milnecarry, 0, false)
			end
		elseif player.aiming*P_MobjFlip(player.mo) > 0
			P_SetObjectMomZ(player.milnecarry, min(AngleFixed(player.aiming), 20*FRACUNIT), false)
		else
			P_SetObjectMomZ(player.milnecarry, 0, false)
		end
		
		P_InstaThrust(player.milnecarry, player.mo.angle, max(speed*player.mo.scale, player.speed*2))
		
		P_TryMove(player.milnecarry, player.milnecarry.x+player.milnecarry.momx,
		player.milnecarry.y+player.milnecarry.momy, true)
		player.milnecarry.z = $+player.milnecarry.momz
	elseif not P_PlayerInPain(player) and player.powers[pw_super] != 1
		player.mo.state = S_PLAY_WALK
	end
		
	player.milneprevflags = nil
	player.milnecarry = nil
end

function A_MonitorPop(actor, var1, var2)
    super(actor, var1, var2)
	if actor.milnethrown
		actor.fuse = 0
		if actor.info.deathstate == S_REDBOX_POP1
			actor.state = S_REDBOX_POP2
		elseif actor.info.deathstate == S_BLUEBOX_POP1
			actor.state = S_BLUEBOX_POP2
		else
			actor.state = S_BOX_POP2
		end
		if multiplayer
			actor.tics = TICRATE*5
		end
		actor.flags = $&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
	end
end

//If a player leaves, make sure they drop whatever they were carrying first!
addHook("PlayerQuit", function(player)
	if player.milnecarry and player.milnecarry.valid
		DropMilneCarry(player, false)
	end
end)

//Spawn an afterimage for the crystal, and shatter it when it breaks
//With MF2_BOSSNOTRAP, it slows down until it breaks
addHook("MobjThinker", function(mobj)
	if mobj.state == S_THROWNCRYSTAL and mobj.fuse != TICRATE*3
		P_SpawnGhostMobj(mobj)
		if mobj.flags2&MF2_BOSSNOTRAP
			mobj.momx = FixedMul($, FRACUNIT*92/100)
			mobj.momy = FixedMul($, FRACUNIT*92/100)
			mobj.momz = FixedMul($, FRACUNIT*92/100)
			
			if (abs(mobj.momx) < mobj.scale*4 and abs(mobj.momy) < mobj.scale*4
			and abs(mobj.momz) < mobj.scale*4)
				S_StartSound(mobj, sfx_shattr)
				P_KillMobj(mobj)
				mobj.momx = 0
				mobj.momy = 0
				mobj.momz = 0
			end
		end
	elseif not mobj.threshold and mobj.state == S_SMOKE1
		local i = 0 while i < 4
			local explode = P_SpawnMobjFromMobj(mobj,0,0,0,MT_SHATTERCRYSTAL)
			if explode and explode.valid
				explode.scale = mobj.scale/2
				explode.threshold = P_RandomKey(2)
				P_InstaThrust(explode, mobj.angle+ANGLE_180+ANGLE_45-((ANGLE_22h)*i), 5*mobj.scale)
				P_SetObjectMomZ(explode, 10*FRACUNIT, false)
				explode.fuse = TICRATE*3
			end
			i = $+1
		end
		mobj.threshold = 1
	end
end, MT_THROWNCRYSTAL)

addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.type == MT_THROWNCRYSTAL
		S_StartSound(inflictor, sfx_mlshtr)
	end
end)

//Spin the crystal debris
addHook("MobjThinker", function(mobj)
	if mobj.threshold
		mobj.rollangle = $-ANGLE_22h
	else
		mobj.rollangle = $+ANGLE_22h
	end
end, MT_SHATTERCRYSTAL)

//Crystal Shield Thinker
addHook("MobjThinker", function(mobj)
	if mobj.threshold
		if not (mobj.target and mobj.target.valid and mobj.target.player
		and mobj.target.player.milneshield)
		P_KillMobj(mobj) return end
		
		if (mobj.target.player.powers[pw_shield] & SH_NOSTACK) != SH_NONE
		or mobj.target.skin == "milne"
		mobj.target.player.milneshield = 0 P_KillMobj(mobj) return end
		
		mobj.scale = FixedMul(mobj.target.scale, mobj.target.player.shieldscale)
		
		if mobj.target.player.powers[pw_invulnerability] > 1
		or mobj.target.player.powers[pw_super]
			if mobj.fuse then mobj.fuse = TICRATE*5 end
			mobj.flags2 = $|MF2_DONTDRAW
		else
			mobj.flags2 = $&~MF2_DONTDRAW
		end
		
		if mobj.target.player.milneshield > 1
			mobj.state = S_MILNECRYSTALORB1
		else
			mobj.state = S_MILNECRYSTALORB2
		end
	end
end, MT_MILNECRYSTAL_ORB)

//Make it so the shield actually protects you
addHook("MobjDamage", function(target)
	if target and target.valid and target.player and target.player.milneshield
		if target.player.milneshield > 1
			S_StartSound(target, sfx_crycrk)
		else
			S_StartSound(target, sfx_crysha)
			//Spawn the explosions
			local i = 0 while i < 16
				local explode = P_SpawnMobjFromMobj(target,0,0,target.height/2,MT_SHATTERCRYSTAL)
				if explode and explode.valid
					explode.scale = target.destscale*3/2
					explode.fuse = TICRATE*3
					explode.angle = (ANGLE_22h*i)+ANGLE_180
					explode.rollangle = FixedAngle(P_RandomKey(360)*FRACUNIT)
					explode.threshold = P_RandomKey(2)
					P_InstaThrust(explode,explode.angle,8*FRACUNIT)
					explode.momz = explode.momx+(P_GetMobjGravity(explode)*-4)
					P_InstaThrust(explode,(target.player.cmd.angleturn<<16)+ANGLE_90,explode.momy)
				end
				i = $+1
			end
		end
		P_SwitchShield(target.player, SH_PITY)
		target.player.milneshield = $-1
	end
end, MT_PLAYER)

//Crystal Shield Ability
//Milne can never do this because she can't give this shield to herself
addHook("JumpSpinSpecial", function(player)
	if player.mo and player.mo.valid and player.milneshield
		if player.pflags&PF_USEDOWN or player.pflags&PF_THOKKED
		or player.pflags&PF_SHIELDABILITY
		or (player.milnecarry and player.milnecarry.valid)
		or not (player.pflags&PF_JUMPED) return end
		
		S_StartSound(player.mo, sfx_crysha)
		local i = 0 while i < 32
			local crystal = P_SPMAngle(player.mo, MT_THROWNCRYSTAL,
			player.mo.angle-((ANGLE_11hh)*i), 0, MF2_BOSSNOTRAP)
			i = $+1
		end
		
		player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
		player.milneshield = 0
		return true
	end
end)

//When one of Milne's crystals hits a player, give them a Crystal Shield
//It overrides Pity shields if Battle Mod isn't added
//This is because the shield-stacking mechanics don't play nice with
//the Crystal Shield being a fake shield
addHook("ShouldDamage", function(target, inflictor, source)
	if milneshield and target and target.valid and target.player and target.skin != "milne"
	and inflictor and inflictor.valid and inflictor.type == MT_THROWNCRYSTAL
	and source and source.valid and source.player
	and ((target.player.powers[pw_shield] & SH_NOSTACK) == SH_NONE
	or (((target.player.powers[pw_shield] & SH_NOSTACK) == SH_PITY
	or (target.player.powers[pw_shield] & SH_NOSTACK) == SH_PINK)) and not (CBW_Battle))
	and not target.player.milneshield and (gametyperules&GTR_FRIENDLY or
	(G_GametypeHasTeams() and target.player.ctfteam == source.player.ctfteam))
		P_SwitchShield(target.player, SH_NONE)
		S_StartSound(target, sfx_crshld)
		target.player.milneshield = 2
		local shield = P_SpawnMobjFromMobj(target,0,0,0,MT_MILNECRYSTAL_ORB)
		if shield and shield.valid
			shield.target = target
			shield.tracer = target
			//The game crashes in software when trying to adjust the scale
			//of an object with MF2_LINKDRAW, so we're not using it
			//shield.flags2 = $|MF2_LINKDRAW
			shield.threshold = 1
		end
	end
end, MT_PLAYER)

//Reset the variables on spawn
addHook("PlayerSpawn", function(player)
	player.milnekick = false
	player.milneshield = 0
	player.milnecarry = nil
	player.milnespringtime = 0
end)

//
//Main Thinker
//
addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "milne")
		if player.milnekick
			P_RestoreMusic(player)
			player.milnekick = false
			if player.mo and player.mo.valid
				player.mo.state = S_PLAY_STND
			end
		end
		//Reset the object you're carrying
		if player.milnecarry and player.milnecarry.valid
			DropMilneCarry(player, false)
		end
	return end
		
	//Break walls and floors during the Thok
	//Also break walls while running
	if player.mo.state == S_PLAY_SPINDASH
	or (player.mo.state == S_PLAY_RUN and P_IsObjectOnGround(player.mo))
	and not player.milnecarry
		local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
		if sectorthing.valid and player.mo.state == S_PLAY_SPINDASH then
			for fof in sectorthing.ffloors()
				if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
				and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
					EV_CrumbleChain(player.sectorthing, fof)
				end
			end
		end
		if player.charability == CA_NONE
			player.charability = CA_GLIDEANDCLIMB
		end
	elseif player.charability == CA_GLIDEANDCLIMB
		player.charability = CA_NONE
	end
	
	//Detect when we press Custom 3
	if not (player.cmd.buttons & BT_CUSTOM3)
		player.milne3tapready = true
		player.milne3tapping = false
	elseif player.milne3tapready then
		player.milne3tapping = true
		player.milne3tapready = false
	else
		player.milne3tapping = false
	end
	
	//Disallows the rest of the code in certain circumstances
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or player.powers[pw_carry] != CR_NONE
	or player.spectator
	or player.playerstate != PST_LIVE
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.powers[pw_nocontrol] > 0
		if player.milnekick
			P_RestoreMusic(player)
			player.milnekick = false
		end
		
		if player.powers[pw_carry] == CR_ROPEHANG
			player.weapondelay = max($, 5)
		end
		
		player.milnemomz = 0
		
		//Reset the object you're carrying
		if player.milnecarry and player.milnecarry.valid
			DropMilneCarry(player, false)
		end

		//Death Effect
		if player.playerstate == PST_DEAD then
			if player.deadtimer < 7
				P_SetScale(player.mo, player.mo.scale+(player.deadtimer*FRACUNIT/28))
			elseif player.deadtimer == 7
				S_StartSound(player.mo, sfx_crysha)
				//Spawn the explosions
				local i = 0 while i < 16
					local explode = P_SpawnMobjFromMobj(player.mo,0,0,player.mo.height/2,MT_SHATTERCRYSTAL)
					if explode and explode.valid
						explode.scale = player.mo.destscale*3/2
						explode.fuse = TICRATE*3
						explode.angle = (ANGLE_22h*i)+ANGLE_180
						explode.rollangle = FixedAngle(P_RandomKey(360)*FRACUNIT)
						explode.threshold = P_RandomKey(2)
						P_InstaThrust(explode,explode.angle,8*FRACUNIT)
						explode.momz = explode.momx+(P_GetMobjGravity(explode)*-4)
						P_InstaThrust(explode,(player.cmd.angleturn<<16)+ANGLE_90,explode.momy)
					end
					i = $+1
				end
				player.mo.flags2 = $ | MF2_DONTDRAW
			end
			//Make her invisible and not move off the map
			player.mo.momz = P_GetMobjGravity(player.mo)*-1
			player.mo.flags = $ | MF_NOGRAVITY & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
		end
	return end
	
	local lockon
	//Handle the carrying junk
	if player.milnecarry and player.milnecarry.valid
	
		//If Milne is spinning...
		//No. Stop. Get some help.
		if player.pflags&PF_SPINNING
			player.pflags = $&~PF_SPINNING
		end
		
		//Reset the rollangle for whatever you're carrying
		if player.milnecarry.rollangle != 0
			player.milnecarry.rollangle = 0
		end
		
		//Set the angle and animation
		//But, if the player we're carrying is jumping, set them free
		if player.milnecarry.player
			if player.milnecarry.player.pflags&PF_JUMPED
				local prevcarry = player.milnecarry
				DropMilneCarry(player, false)
				prevcarry.player.pflags = $|PF_JUMPED&~PF_SPINNING
				prevcarry.player.jumping = true
				prevcarry.state = S_PLAY_JUMP
				return
			end
			player.milnecarry.player.drawangle = player.drawangle
			
			//Milne uses carry type 13, which is unused normally
			//Except when Yoshi uses it
			player.milnecarry.tracer = player.mo
			player.milnecarry.player.powers[pw_carry] = 13
			
			if gametyperules&GTR_FRIENDLY or
			(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam)
				player.milnecarry.state = S_PLAY_ROLL
			else
				player.milnecarry.state = S_PLAY_PAIN
			end
		else
			player.milnecarry.angle = player.drawangle
		end
		
		//Set the momentum
		player.milnecarry.momx = player.mo.momx
		player.milnecarry.momy = player.mo.momy
		player.milnecarry.momz = player.mo.momz
		
		//Set the position
		local zdist
		P_TryMove(player.milnecarry, player.mo.x, player.mo.y, true)
		if player.mo.flags2&MF2_OBJECTFLIP
			player.milnecarry.flags2 = $|MF2_OBJECTFLIP
			player.milnecarry.z = player.mo.z-(5*player.mo.scale)-player.milnecarry.height
			zdist = player.mo.z - (player.milnecarry.z + player.milnecarry.height)
		else
			player.milnecarry.flags2 = $&~MF2_OBJECTFLIP
			player.milnecarry.z = player.mo.z+player.mo.height+(5*player.mo.scale)
			zdist = (player.mo.z + player.mo.height) - player.milnecarry.z
		end
		
		//If the object is too far away even after moving, just drop what we're carrying
		local dist = P_AproxDistance(player.mo.x-player.milnecarry.x, player.mo.y-player.milnecarry.y)
		dist = P_AproxDistance(dist, zdist)
		if dist > player.mo.radius*2 and not player.weapondelay
			DropMilneCarry(player, false)
			return
		end
		
		//Do the carrying animation
		if P_IsObjectOnGround(player.mo) and player.speed == 0
			player.mo.state = S_PLAY_GLIDE_LANDING
		else
			player.mo.state = S_PLAY_GLIDE
			if player.pflags&PF_JUMPED
				player.mo.frame = 2
			elseif player.skidtime
				player.mo.frame = 0
			elseif player.speed > 14*player.mo.scale
				player.mo.frame = (leveltime%16)/2
			elseif player.speed > 7*player.mo.scale
				player.mo.frame = (leveltime%24)/3
			else
				player.mo.frame = (leveltime%32)/4
			end
		end
		
		//Spawn a lockon reticle if we can
		lockon = P_LookForEnemies(player, false, not(player.milneprevflags&MF_PUSHABLE))
		if lockon and lockon.valid and (player.milneprevflags&MF_ENEMY
		or player.milneprevflags&MF_MONITOR or player.milneprevflags&MF_PUSHABLE
		or player.milnecarry.player)
			P_SpawnLockOn(player, lockon, S_LOCKON1)
		end
		
		return
	end
	
	//Team Fortress 2!!
	//Epic
	if player.milnekick
		if not (P_IsObjectOnGround(player.mo) or player.powers[pw_super]
		or player.powers[pw_justlaunched]) or player.milne3tapping
			player.mo.state = S_PLAY_WALK
			P_RestoreMusic(player)
			player.milnekick = false
		else
			if player.powers[pw_underwater] > 11*TICRATE
			or not (player.mo.eflags&MFE_UNDERWATER)
				S_ChangeMusic("MILNEKICK", true, player)
			end
			if (player.mo.frame == A or player.mo.frame == E)
			and player.mo.state == S_MILNE_KICK and not player.powers[pw_super]
				player.mo.friction = FRACUNIT/8
			else
				player.mo.friction = FRACUNIT
			end
			if player.mo.state != S_MILNE_KICK
				player.mo.state = S_MILNE_KICK
				player.mo.frame = D
				player.milnekick = true
			end
			//Super Speed
			if player.powers[pw_super]
				local stupid = ((leveltime%4)*2)-1
				if stupid < 0 or stupid > 7
					stupid = 7
				end
				player.mo.frame = stupid
				P_SpawnGhostMobj(player.mo)
			else
				player.pflags = $|PF_JUMPSTASIS
			end
		end
	elseif (P_IsObjectOnGround(player.mo) or player.powers[pw_super]
		or player.powers[pw_justlaunched]) and player.milne3tapping
		player.milnekick = true
	end
	
	//Get a boost from thokking into springs
	if player.milnespringtime
		if (player.mo.eflags & MFE_SPRUNG)
			player.milnespringtime = 0
			player.mo.momz = $*5/4
			player.mo.momx = $*5/4
			player.mo.momy = $*5/4
			S_StartSound(player.mo, sfx_sprong)
			if (player.mo.eflags & MFE_UNDERWATER)
				local ex = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_UWEXPLODE)
				if ex and ex.valid ex.scale = $/2 end
			else
				P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale*P_MobjFlip(player.mo), MT_SPINDUST)
			end
		elseif P_IsObjectOnGround(player.mo) or player.mo.state != S_PLAY_SPINDASH
			player.milnespringtime = 0
		else
			player.milnespringtime = $-1
		end
	end
	
	//Make the spinning animation go faster when we're above our normalspeed
	if player.mo.state == S_PLAY_SPINDASH and player.speed >= player.normalspeed
	and player.mo.tics == 2
		player.mo.tics = 1
	end
end)



//Double Jump Thok
//Give this a cool name later
//...we never gave it a cool name :(
addHook("AbilitySpecial", function(player)
	if not (player.mo and player.mo.skin == "milne") return end
	
	//Don't do it if you're holding the button, used a shield
	//are carrying something, or didn't even jump
	if player.pflags&PF_JUMPDOWN or player.pflags&PF_SHIELDABILITY
	or (player.milnecarry and player.milnecarry.valid)
	or player.gotcrystal
	or not (player.pflags&PF_JUMPED) return true end
	
	//The downwards jump
	if player.pflags&PF_THOKKED
		if player.powers[pw_super]
			player.pflags = $&~PF_THOKKED
		else
			player.pflags = $&~PF_JUMPED
		end
		
		if player.mo.eflags&MFE_UNDERWATER
			P_SetObjectMomZ(player.mo, -12*FRACUNIT, true)
		else
			P_SetObjectMomZ(player.mo, -15*FRACUNIT, true)
		end
		
		S_StartSound(player.mo, sfx_mldown)
	//The upwards jump
	else
		player.pflags = $&~PF_JUMPED
		P_DoJump(player, false)
		player.pflags = $|PF_JUMPED|PF_THOKKED
		player.jumping = true
		S_StartSound(player.mo, sfx_thok)
	end
	
	//The Thok part (only executes if you're holding far enough in a direction)
	if not (P_GetPlayerControlDirection(player) == 0
	or (abs(player.cmd.forwardmove) < 35 and abs(player.cmd.sidemove) < 35))
		local actionspd = max(player.actionspd, player.normalspeed)
		if player.mo.eflags&MFE_UNDERWATER
			actionspd = $*2/3
		end
		
		if player.milneshield
			actionspd = $/2
		end
		if player.speed <= FixedMul(actionspd, player.mo.scale)
			P_InstaThrust(player.mo, player.mo.angle, FixedMul(actionspd, player.mo.scale))
		else
			P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.rmomx,player.rmomy))
		end
		player.drawangle = player.mo.angle
	end
	
	//Other stuff
	player.mo.state = S_PLAY_SPINDASH
	P_SpawnThokMobj(player)
	player.pflags = $&~PF_SPINNING&~PF_STARTDASH
	player.milnespringtime = TICRATE/2
	return true
end)

//Allows you to attack using the Thok
addHook("PlayerCanDamage", function(player, mobj)
	if not (player.mo and player.mo.skin == "milne") return end
	
	if player.mo.state == S_PLAY_SPINDASH
		return true
	end
end)

//Destroy spikes via the Thok and running into them
local waterspike = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing.player and tmthing.skin == "milne" and (tmthing.state == S_PLAY_SPINDASH
	or (tmthing.state == S_PLAY_RUN and tmthing.eflags&MFE_ONGROUND and not tmthing.player.milnecarry))
	and (abs(thing.z - tmthing.z) <= 60*tmthing.scale)
		if tmthing.z >= thing.z-tmthing.height and tmthing.z <= thing.z+thing.height+tmthing.height
			P_KillMobj(thing, tmthing)
			return true
		end
	end
end
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_WALLSPIKE)

//Screw it, make ALL pushables hurt enemies if they're off the ground
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and thing.health and thing.flags&MF_ENEMY
	and tmthing and tmthing.valid and tmthing.flags&MF_PUSHABLE and not tmthing.mo.battleobject
	and not P_IsObjectOnGround(tmthing) and (abs(thing.z - tmthing.z) <= 60*tmthing.scale)
		P_DamageMobj(thing, tmthing, tmthing, 1)
	end
end)

//If you're throwing or are holding an object, shields can't be used
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "milne"
		if player.mo.state == S_PLAY_FIRE
		or (player.milnecarry and player.milnecarry.valid)
			return true
		end
	end
end)

//Throw an object we're carrying, look for a new object to pick up, or do the Crystal Toss
addHook("SpinSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "milne") return end
	
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or player.powers[pw_carry] != CR_NONE
	or player.spectator
	or player.playerstate != PST_LIVE
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.powers[pw_nocontrol] > 0
	or player.milnekick
	or player.climbing
	or player.pflags&PF_USEDOWN
	or P_SuperReady(player) return end
	
	//Throw the object we're carrying
	if player.milnecarry and player.milnecarry.valid
		S_StartSound(player.mo, sfx_mltoss)
		player.mo.state = S_PLAY_FIRE
		player.weapondelay = TICRATE/2
		
		DropMilneCarry(player, true)
		
	//Look for an object to carry
	else
		local maxdist = FixedMul(RING_DIST/3, player.mo.scale)+player.speed
		local span = ANGLE_45
		local thokmobj = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_THOK)
		thokmobj.radius = maxdist
		local closestmo = nil
		local closestdist = 0

		searchBlockmap("objects", function(refmobj, mo)
			local trash = R_PointToAngle2(player.mo.x, player.mo.y, mo.x, mo.y)
		
			if mo.flags & MF_NOCLIPTHING or mo.health <= 0
			or mo == player.mo or mo.flags2 & MF2_FRET or not P_CheckSight(player.mo, mo)
			or ((twodlevel or player.mo.flags2 & MF2_TWOD) and abs(player.mo.y-mo.y) > player.mo.radius)
			or ((trash - player.mo.angle > span) or (trash - player.mo.angle < -1*span))
			return end

			if mo.player
				if not milneable or player.bot == 1
				or mo.player.spectator or mo.player.panim == PA_PAIN or G_TagGametype()
				or mo.player.powers[pw_invulnerability] > 1
				or (mo.player.powers[pw_super] and not (gametyperules&GTR_FRIENDLY))
				or mo.player.powers[pw_flashing]
					return
				//No picking up attacking players in Battle
				elseif CBW_Battle
					CBW_Battle.DoSPriority(mo.player, player.mo)
					if mo.player.battle_def then return end
				end
			elseif not ((mo.flags&MF_ENEMY and mo.health == 1 and mo.type != MT_YELLOWSHELL)
			or (mo.flags&MF_PUSHABLE and mo.type != MT_MINECART
			and mo.type != MT_CYBRAKDEMON_ELECTRIC_BARRIER and milneable)
			or (mo.flags&MF_MONITOR and not (mo.flags&MF_GRENADEBOUNCE)
			and (mo.type != MT_RING_REDBOX or player.ctfteam == 1)
			and (mo.type != MT_RING_BLUEBOX or player.ctfteam == 2)))
				return // not a valid target
			end
		
			local zdist = ((player.mo.z + player.mo.height/2) - (mo.z + mo.height/2))*3/2
			local dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)
			if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2) and ((R_PointToAngle2(0, 0, dist, -1*zdist) + span) > span*2)
				return // Don't home outside of desired angle!
			end

			dist = P_AproxDistance(dist, zdist)
			if (dist > maxdist) or (closestmo and dist > closestdist)
				return // out of range
			end

			closestmo = mo
			closestdist = dist
		end, thokmobj)
	
		P_RemoveMobj(thokmobj)
		
		if closestmo and closestmo.valid
			if closestmo.player
				if closestmo.player.powers[pw_carry] == CR_ROPEHANG
					closestmo.tracer = nil
				end
				
				P_ResetPlayer(closestmo.player)
				
				//Destroy the player's minecart without killing them
				if closestmo.player.powers[pw_carry] == CR_MINECART
					closestmo.tracer.target = nil
					P_KillMobj(closestmo.tracer, closestmo, player.mo, 0)
				end
				
				//Milne uses carry type 13, which is unused normally
				//Except when Yoshi uses it
				closestmo.tracer = player.mo
				closestmo.player.powers[pw_carry] = 13
				
				if gametyperules&GTR_FRIENDLY or
				(G_GametypeHasTeams() and closestmo.player.ctfteam == player.ctfteam)
					closestmo.state = S_PLAY_ROLL
				else
					closestmo.state = S_PLAY_PAIN
				end
				
			elseif closestmo.type == MT_GSNAPPER
				local dead = closestmo
				closestmo = P_SpawnMobjFromMobj(dead,0,0,0,MT_BLUECRAWLA)
				P_KillMobj(dead)
				P_SetMobjStateNF(closestmo, mobjinfo[MT_GSNAPPER].spawnstate)
				closestmo.tics = -1
				
			elseif closestmo.flags&MF_MONITOR
				if multiplayer and CV_FindVar("respawnitem")
					closestmo.state = S_INVISIBLE
					closestmo.flags = $|MF_NOCLIPTHING
					closestmo.fuse = CV_FindVar("respawnitemtime").value*TICRATE + 2
					closestmo = P_SpawnMobjFromMobj(closestmo,0,0,0,closestmo.type)
				end
				closestmo.state = closestmo.info.spawnstate
			else
				if closestmo.flags&MF_ENEMY
					if closestmo.tracer and closestmo.tracer.valid and not closestmo.tracer.player
					and closestmo.type != MT_BUMBLEBORE
						P_KillMobj(closestmo.tracer, player.mo, player.mo)
						if closestmo.target and closestmo.target.valid and not closestmo.target.player
							P_KillMobj(closestmo.target, player.mo, player.mo)
						end
					end
					closestmo.health = 0
				end
				if closestmo.type == MT_MINUS
					P_SetMobjStateNF(closestmo, closestmo.info.missilestate)
				else
					P_SetMobjStateNF(closestmo, closestmo.info.spawnstate)
				end
				closestmo.tics = -1
			end
			
			player.milneprevflags = closestmo.flags
			closestmo.flags = MF_NOCLIPTHING|MF_SLIDEME|MF_NOGRAVITY
			player.weapondelay = 8*TICRATE
			S_StartSoundAtVolume(player.mo, sfx_s3k8a, 128)
			P_SpawnGhostMobj(closestmo)
			player.milnecarry = closestmo
		
		//Crystal Toss
		//No doing it when you can use a shield ability!
		elseif ((player.powers[pw_shield] & SH_NOSTACK) == SH_NONE
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_PITY
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_PINK
		or P_IsObjectOnGround(player.mo) or not (player.pflags&PF_JUMPED)
		or player.pflags&PF_THOKKED or player.pflags&PF_SHIELDABILITY)
		and not player.weapondelay
			S_StartSound(player.mo, sfx_crythr)
			
			local i = 0 while i < 3
				local crystal = P_SPMAngle(player.mo, MT_THROWNCRYSTAL,
				player.mo.angle+(ANGLE_11hh/2)-((ANGLE_11hh/2)*i), 0, MF2_BOSSNOTRAP)
				if crystal and crystal.valid
					crystal.name = "crystal shards"
				end
				i = $+1
			end
			
			local thok = P_SpawnMobjFromMobj(player.mo,
			P_ReturnThrustX(nil,player.mo.angle,FixedDiv(player.mo.radius,player.mo.scale)),
			P_ReturnThrustY(nil,player.mo.angle,FixedDiv(player.mo.radius,player.mo.scale)),
			FixedDiv(player.mo.height/3,player.mo.scale),MT_THOK)
			local ghost = P_SpawnGhostMobj(thok)
			P_KillMobj(thok)
			ghost.color = SKINCOLOR_SUPERPURPLE2
			ghost.scale = $/8
			ghost.destscale = $*8
			ghost.scalespeed = $*2
			ghost.momx = player.mo.momx*2/3
			ghost.momy = player.mo.momy*2/3
			ghost.momz = player.mo.momz
				
			player.mo.state = S_PLAY_FIRE
			player.mo.momx = $/2
			player.mo.momy = $/2
			player.drawangle = player.mo.angle
			player.pflags = $&~PF_JUMPED&~PF_SPINNING&~PF_STARTDASH
			player.weapondelay = TICRATE/2
		end
	end
end)

//Battle Mod Support
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	
	local function GarbagePriority3(player)
		if player.mo.state == S_PLAY_SPINDASH
			CBW_Battle.SetPriority(player,1,1,nil,1,1,"spinning thok attack")
		end
	end
	
	CBW_Battle.SkinVars["milne"] = {
		weight = 115,
		func_priority_ext = GarbagePriority3
	}
end)